# Neovim Plugins

## Must-haves

- neovim/nvim-lspconfig: enable LSP
- hrsh7th/cmp-nvim-lsp: connect LSP to nvim-cmp
- hrsh7th/cmp-buffer: completion from current buffer
- nvim-lua/plenary.nvim: utility functions for other plugins
- jose-elias-alvarez/null-ls.nvim: auto-trigger linting, formatting
- tpope/vim-surround: surround shortcuts
- tpope/vim-repeat: better repeat with .
- numToStr/Comment.nvim: smart comment shortcut
- lewis6991/impatient.nvim: faster start time
- nvim-treesitter/nvim-treesitter: language parsers
- nvim-telescope/telescope.nvim: fuzzy finder
- nvim-telescope/telescope-project.nvim: jump projects
- akinsho/toggleterm.nvim: embedded floating terminal
- lewis6991/gitsigns.nvim: git in sidebar
- hoob3rt/lualine.nvim: status bar
- kyazdani42/nvim-web-devicons: icons in status bar
- akinsho/bufferline.nvim: tab view for buffers
- moll/vim-bbye: fixes for buffer closing
- kyazdani42/nvim-tree.lua: better sidebar explorer

## Optional

- hrsh7th/cmp-path: completion of file path
- hrsh7th/cmp-cmdline: completion of shell commands
- hrsh7th/cmp-nvim-lua: completion of neovim commands
- L3MON4D3/LuaSnip: snippet engine
- saadparwaiz1/cmp_luasnip: completion of luasnip snippets
- lukas-reineke/cmp-rg: completion of ripgrep search
- rafamadriz/friendly-snippets: pre-generated snippets
- folke/lsp-colors.nvim: LSP error highlights
- tpope/vim-eunuch: file manipulation
- tpope/vim-vinegar: better netrw file explorer
- tpope/vim-fugitive: git commands
- godlygeek/tabular: alignment commands
- jakewvincent/mkdnflow.nvim: markdown notes
- nvim-treesitter/nvim-treesitter-textobjects: syntax-aware textobjects
- chr4/nginx.vim: nginx syntax
- towolf/vim-helm: helm syntax
- rodjek/vim-puppet: puppet syntax
- nvim-telescope/telescope-fzy-native.nvim: faster sorting
- jvgrootveld/telescope-zoxide: jump directories
- nvim-telescope/telescope-file-browser.nvim: view files
- ellisonleao/glow.nvim: view markdown with glow
- norcalli/nvim-colorizer.lua: preview hex colors

# Other Tools

- git
- stylua
- black
- flake8
- fish_indent
- nixfmt
- rustfmt
- shellcheck
- shfmt
- terraform
- luacheck
- markdownlint
- pylint
